diff --git a/src/backend/replication/walreceiver.c b/src/backend/replication/walreceiver.c
index 7c11e1ab44..63a3d0c1e6 100644
--- a/src/backend/replication/walreceiver.c
+++ b/src/backend/replication/walreceiver.c
@@ -761,6 +761,10 @@ WalRcvFetchTimeLineHistoryFiles(TimeLineID first, TimeLineID last)
                         */
                        writeTimeLineHistoryFile(tli, content, len);
 
+                       /* Mark history file as ready for archiving */
+                       if (XLogArchiveMode != ARCHIVE_MODE_OFF)
+                               XLogArchiveNotify(fname);
+
                        pfree(fname);
                        pfree(content);
                }
